/* Classic maze game for OS-9/X680x0.
     Program and file name: maze.c

@@OS-9 ɂ̓Q[Ƃ̂Ȃ̂łAȒPȎvlQ[AW
@Ă݂܂BOĂ܂̂_łAxgCĂ݂ĉB
@IWiEvÓAOh!FM nU pg.130 ɌfڂĂV
@[gEvOłB OS-9 pɎ̂łB
@ȂARpCOɁ}[N̊R[h $7E7E ɕύXĉB

  version  date       author      memo
  -----------------------------------------------------------------------
  1.0     '83.12      HI    Oh!FM u Vol.6 pg.130 uOHv
  2.0     '97.05.18   a@@@OS-9/68000 V2.2  X68030 ɍĈڐA

   Copyright (c) 1999      by Izumi Geotechnical Office inc.
   All rights reserved.         Nagano prep, 399-6101, JAPAN
*/
 
#include <stdio.h>          /* printf() */
#include <X68K/pwindow.h>   /* _pw_getsrvid() */

#define STDIN   0           /* W̓pX */
#define STDOUT  1           /* Wo̓pX */
#define FALSE   -1          /* tbO */
#define TRUE    0           /*     V   */
#define OFFSET  32          /* `̂x␳ */

double
    randomtable[56];
int
    winId,                  /* for X680x0 personal window */
    randomindex,
    m[21][22],
    g[6][2][3] = {
        14,   0, 111, 186, 199, 527,
        54,  15, 141, 145, 185, 497,
        76,  55, 225, 123, 144, 413,
        86,  77, 271, 113, 122, 367,
        93,  87, 292, 106, 112, 346,
         0,  94, 304,   0, 105, 334
    },
    s[51],t[51],x[4],y[4],
    px,py,d,flag,step;
char
    *gd[2] = {"  ",""},      /* R[h $7E7E ɕύX̂ */
    *p[4] = {"\x1c", "\x1e", "\x1d", "\x1f"},      /*  */
    checker[10];

void disptytle(void);
void initmaze(void);
void drawmaze(int);
int mazemap(void);
void clearmemory(void);
void initrandom(void);
int mod(register int, register int);
void randomize(void);
double random(double);
double setseed(void);
void lpr(int, int, char *);
void setdata(register char *);
void cls(void);
void locate(int, int);
void set_pfkeys(void);

int main(void)
{
    int map,k,loop;
    int sx,sy;
    char c;

    set_pfkeys();
    winId = _pw_getsrvid(STDOUT);
    initrandom();
    disptytle();
    do {
        initmaze();
        map = loop = TRUE;
        step = 0;
        k = 1;
        drawmaze(k);
        do {
            lpr(62, 16, "\x1b[K");
            printf("ǂH");
            fflush(stdout);
            read(STDIN, &c, 1);
            switch (c) {
                case '\x1e':      /*  */
                    k = 1;
                    sx = px + x[d];
                    sy = py + y[d];
                    if (m[sx][sy] == 1)
                        printf("\a\n");
                    else {
                        px = sx;
                        py = sy;
                        drawmaze(k);
                    }
                    break;
                case '\x1d':      /*  */
                    k = 2;
                    drawmaze(k);
                    break;
                case '\x1c':      /*  */
                    k = 4;
                    drawmaze(k);
                    break;
                case '\x1f':      /*  */
                    k = 3;
                    drawmaze(k);
                    break;
                case 'm':
                case 'M':
                    k = 5;
                    if (map == TRUE)
                        map = mazemap();
                    break;
                case 'g':
                case 'G':
                    k = 6;
                    lpr(62, 16, "\x1b[K");
                    printf("{(y)H");
                    fflush(stdout);
                    read(STDIN, &c, 1);
                    if (c != 'y' && c != 'Y') {
                        k = 1;
                        step -= 1;
                        drawmaze(k);
                    } else
                        loop = FALSE;
                    break;
                default:
                    break;
            }
            if (px == 19 && py == 20) {
                lpr(32, 5, "\aGoul in !!");
                fflush(stdout);
                sleep(2);
                loop = FALSE;
            }
        } while (loop == TRUE);
        lpr(62, 16, "            \n");
        mazemap();
        do {
            lpr(30, 24, "\x1b[K");
            printf("܂(y/n)H");
            fflush(stdout);
            read(STDIN, &c, 1);
        } while (c != 'y' && c != 'Y' && c != 'n' && c != 'N');
        loop = (c == 'y' || c == 'Y') ? TRUE : FALSE;
    } while (loop == TRUE);
    printf("\n");
    return 0;
}

void disptytle(void)
{
    int xx,yy,attr;
    char c;

    cls();
    xx = 10;
    yy = 7;
    lpr(xx, 0, "<< ̓񎟌H >>\n");
    lpr(xx, yy - 2, "L[̐\n");
    lpr(xx + 11, yy, "O\n");
    lpr(xx + 11, yy + 1, "\x1b[7m\x1b[27m\n");
    lpr(xx + 6, yy + 2, "\x1b[7m\x1b[27m    \x1b[7m\x1b[27mE\n");
    lpr(xx + 11, yy + 3, "\x1b[7m\x1b[27m\n");
    lpr(xx + 11, yy + 4, "\n");
    lpr(xx, yy + 6, "\x1b[7ml\x1b[27mFn}QƁiP̂݁j\n");
    lpr(xx, yy + 8, "\x1b[7mf\x1b[27mF~Q\n");
    lpr(xx, yy + 12, "AL[ĉB");
    fflush(stdout);
    read(STDIN, &c, 1);              /* getc(stdin) ͎gȂ */
}

void initmaze(void)
{
    register int i,j,k;
    int s1,t1,dx,dy,ds,dt,r,temp1,temp2;

    clearmemory();
    x[0] = y[3] = 2;
    x[2] = y[1] = -2;
    for (i = 0; i <= 20; i += 1)
        m[i][0] = m[0][i] = m[i][20] = m[20][i] = 1;
    m[19][20] = 0;
    m[19][21] = 2;
    for (dy = 2; dy <= 18; dy += 2) {
        for (dx = 2; dx <= 18; dx += 2) {
            if (m[dx][dy] != 1) {
                do {
                    ds = dx;
                    dt = dy;
                    k = -1;
                    do {
                        flag = FALSE;
                        k += 1;
                        s[k] = ds;
                        t[k] = dt;
                        m[ds][dt] = 2;
                        r = (int)random(3.0);
                        for (i = 1; i <= 4; i += 1) {
                            s1 = ds + x[r];
                            t1 = dt + y[r];
                            if (m[s1][t1] == 0) {
                                ds = s1;
                                dt = t1;
                                i = 4;
                            } else if (m[s1][t1] == 1) {
                                s[k + 1] = s1;
                                t[k + 1] = t1;
                                for (j = 0; j <= k; j += 1) {
                                    temp1 = s[j];
                                    temp2 = t[j];
                                    m[temp1][temp2] = 1;
                                    temp1 = s[j + 1] + s[j];
                                    temp1 >>= 1;
                                    temp2 = t[j + 1] + t[j];
                                    temp2 >>= 1;
                                    m[temp1][temp2] = 1;
                                }
                                i = 4;
                                flag = TRUE;
                            } else {
                                r = mod(r + 1, 4);
                                if (i == 4) {
                                    for (j = 0; j <= k; j += 1) {
                                        temp1 = s[j];
                                        temp2 = t[j];
                                        m[temp1][temp2] = 0;
                                    }
                                    flag = FALSE;
                                }
			    }
                        }
                    } while (flag != TRUE);
                } while (flag != TRUE);
            }
        }
    }
    px = 2 * (int)random(8.0) + 1;
    py = 2 * (int)random(8.0) + 1;
    d = (int)random(3.0);
    x[0] = y[3] = 1;
    x[2] = y[1] = -1;
}

void drawmaze(int k)
{
    register int i;
    int di,ds,dt,lx,ly,rx,ry,stylef,func,color;

    func = stylef = 0;
    d = mod(d + k - 1, 4);
    di = mod(d + 1, 4);
    ds = px;
    dt = py;
    cls();
    for (i = 1; i <= 5; i += 1) {
        lx = ds + x[di];
        ly = dt + y[di];
        rx = ds - x[di];
        ry = dt - y[di];
        ds += x[d];
        dt += y[d];
        _wg_locate(STDOUT, winId, g[i-1][0][2], g[i-1][0][m[lx][ly]] + OFFSET);
        _wg_line(STDOUT, winId, g[i][0][2], g[i-1][0][0] + OFFSET);
        _wg_line(STDOUT, winId, g[i][0][2], g[i-1][1][0] + OFFSET);
        _wg_line(STDOUT, winId, g[i-1][0][2], g[i-1][1][m[lx][ly]] + OFFSET);
        _wg_locate(STDOUT, winId, g[i-1][1][2], g[i-1][0][m[rx][ry]] + OFFSET);
        _wg_line(STDOUT, winId, g[i][1][2], g[i-1][0][0] + OFFSET);
        _wg_line(STDOUT, winId, g[i][1][2], g[i-1][1][0] + OFFSET);
        _wg_line(STDOUT, winId, g[i-1][1][2], g[i-1][1][m[rx][ry]] + OFFSET);
        if (m[ds][dt] == 1) {
            _wg_locate(STDOUT, winId, g[i][0][2], g[i-1][0][0] + OFFSET);
            _wg_rect(STDOUT, winId, g[i][1][2] + 1, g[i-1][1][0] + OFFSET);
            break;
        } else if (m[ds][dt] == 2)
            break;
    }
    if (i > 5) {
        _wg_locate(STDOUT, winId, 305, 94 + OFFSET);
        _wg_line(STDOUT, winId, 333, 105 + OFFSET);
        _wg_locate(STDOUT, winId, 333, 94 + OFFSET);
        _wg_line(STDOUT, winId, 305, 105 + OFFSET);
    }
    _pw_flush(STDOUT, winId, 4, 4, 636, 246 + OFFSET, 0);
    locate(34, 0);
    printf("STEP %d\n", step++);
}

int mazemap(void)
{
    int i,j;
    int temp_x,temp_y;

    printf("\x1b[1v\n");             /* J[\EmuN */
    for (j = 0; j <= 20; j += 1) {
        locate(19, j + 3);
        fflush(stdout);
        for (i = 0; i <= 20; i += 1)
            write(STDOUT, gd[m[i][j]], 2);
    }
    printf("\x1b[0v\n");             /* J[\EuN */
    temp_x = px * 16 + 156;
    temp_y = py * 16 + 37;
    _wg_locate(STDOUT, winId, temp_x, temp_y);
    _wg_text(STDOUT, winId, p[d]);
    _pw_flush(STDOUT, winId, temp_x, temp_y, temp_x + 16, temp_y + 16, 0);
    return FALSE;
}

void clearmemory(void)
{
    register int i,j;
    for (i = 0; i < 21; i += 1) {
        for (j = 0; j < 22; j += 1)
            m[i][j] = 0;
    }
    for (i = 0; i < 51; i += 1)
        s[i] = t[i] = 0;
    for (i = 0; i < 4; i += 1)
        x[i] = y[i] = 0;
}

void initrandom(void)          /* l */
{
    /* uRs[^EASYTvF pg.125 Zp]_Њ */
    register int i,j;
    double seed,r;

    seed = setseed();
    randomtable[55] = seed;
    r = 2.220446e-16;          /* machine epsilon */
    for (i = 1; i <= 54; i += 1) {
        j = mod(21 * i, 55);
        randomtable[j] = r;
        r = seed - r;
        if (r < 0.0)
            r += 1.0;
        seed = randomtable[j];
    }
    randomize();
    randomize();
    randomize();
    randomindex = 55;
}

int mod(register int a, register int b)
{
    register int c;
    c = a / b;
    return a - b * c;
}

void randomize(void)
{
    register int i;
    register double r;
    for (i = 1; i <= 24; i += 1) {
        r = randomtable[i] - randomtable[i + 31];
        randomtable[i] = (r >= 0.0 ? r : r + 1.0);
    }
    for (i = 25; i <= 55; i += 1) {
        r = randomtable[i] - randomtable[i - 24];
        randomtable[i] = (r >= 0.0 ? r : r + 1.0);
    }
}

double random(double v)
{
    randomindex += 1;
    if (randomindex > 55) {
        randomize();
        randomindex = 1;
    }
    v *= randomtable[randomindex];
    return v;
}

double setseed(void)
{
    register int temp;
    int date,time,tick;
    short day;
    char buf[14];
    _sysdate(0, &time, &date, &day, &tick);
    temp = (time & 0x000000ff);             /* second */
    sprintf(&buf[0], "%2d", temp);
    temp = (time & 0x0000ff00);             /* minute */
    temp >>= 8;
    sprintf(&buf[2], "%2d", temp);
    temp = (time & 0x00ff0000);             /* hour */
    temp >>= 8;
    temp >>= 8;
    sprintf(&buf[4], "%2d", temp);
    temp = (date & 0x0000ff00);             /* month */
    temp >>= 8;
    sprintf(&buf[6], "%2d", temp);
    temp = (date & 0x000000ff);             /* day */
    sprintf(&buf[8], "%2d", temp);
    temp = (date & 0xffff0000);             /* year */
    temp >>= 8;
    temp >>= 8;
    temp -= (temp / 100) * 100;
    sprintf(&buf[10], "%2d\n", temp);
    setdata(buf);
    return atof(buf) / 595923123200.0;   /* 59b59231232??N */
}

void lpr(int lx, int ly, char *lp)
{
    locate(lx, ly);
    printf(lp);
}

void setdata(register char *s)
{
    while (*s != '\n') {
        if (*s == ' ')
            *s = '0';
        s++;
    }
}

void cls(void)
{
    printf("\x1b[2J\n");
}

void locate(int lx, int ly)
{
    printf("\x1b[%d;%dH", ly, lx);
}

void set_pfkeys(void)
{
    printf("\x1b[25;1z%\x1e");            /*  */
    printf("\x1b[26;1z%\x1d");            /*  */
    printf("\x1b[27;1z%\x1c");            /*  */
    printf("\x1b[28;1z%\x1f");            /*  */
}

